if (typeof(String.prototype.removeHTMLTag) == "undefined") {
  String.prototype.removeHTMLTag = function () {
    return this.replace(/<.+?>([^<>]+?)<.+?>/g, '$1')
  }
}
;(function (a, b) {
  var c = b(a);
  if (typeof define === 'function' && define.amd) {
    define([], b)
  } else if (typeof module !== 'undefined' && module.exports) {
    module.exports = b()
  } else {
    a.ws = b()
  }
}(this || window, function (a, b) {
  if (!('WebSocket' in window)) return;
  var c = {}, d, e = document.createElement('div'),
    f = {automaticOpen: true, reconnectDecay: 1.5, host: "127.0.0.1", port: 54321, protocol: "ws",},
    func = function (g) {
      switch (g.type) {
        case"connecting":
          console.log("Connecting to cfprint.", g);
          break;
        case"open":
          console.log("Connected to cfprint.", g);
          break;
        case"close":
          console.log("Disconnected from cfprint.", g);
          break;
        case"message":
          console.log("Got a message from cfprint: " + g.data, g);
          break;
        case"error":
          console.log("A error occured: " + g.data, g);
          break;
        default:
          console.log("EVENT: ", g)
      }
    }, _api = {
      CONNECTING: WebSocket.CONNECTING,
      OPEN: WebSocket.OPEN,
      CLOSING: WebSocket.CLOSING,
      CLOSED: WebSocket.CLOSED
    };

  function ws(g, h, i) {
    var j = this;
    this.ver = "1.3.8.1";
    if (!i) {
      i = {}
    }
    ;
    for (var k in f) {
      if (typeof i[k] !== 'undefined') this[k] = i[k]; else this[k] = f[k]
    }
    ;this.host = g || this.host;
    this.port = h || this.port;
    this.url = this.getURL();
    this.readyState = WebSocket.CONNECTING;
    for (var l in _api) this[l] = _api[l];
    e.addEventListener('connecting', function (m) {
      j !== window && j.onconnecting(m)
    });
    e.addEventListener('open', function (m) {
      j !== window && j.onopen(m)
    });
    e.addEventListener('message', function (m) {
      j !== window && j.onmessage(m)
    });
    e.addEventListener('close', function (m) {
      j !== window && j.onclose(m)
    });
    e.addEventListener('error', function (m) {
      j !== window && j.onerror(m)
    });
    this.addEventListener = e.addEventListener.bind(e);
    this.removeEventListener = e.removeEventListener.bind(e);
    this.dispatchEvent = e.dispatchEvent.bind(e);
    if (this.automaticOpen === true && this !== window) this.open();
    return this
  };

  function generateEvent(g, h) {
    var i = document.createEvent("CustomEvent");
    i.initCustomEvent(g, false, false, h);
    return i
  };ws.prototype.onconnecting = func;
  ws.prototype.onopen = func;
  ws.prototype.onmessage = func;
  ws.prototype.onclose = func;
  ws.prototype.onerror = func;
  ws.prototype.setProtocol = function (g) {
    if (this.wsocket) {
      this.protocol = g
    }
  };
  ws.prototype.setPort = function (g) {
    if (this.wsocket) {
      this.port = g
    }
  };
  ws.prototype.setHost = function (g) {
    if (this.wsocket) {
      this.host = g
    }
  };
  ws.prototype.getURL = function (g) {
    if (this.wsocket && this.wsocket.readyState === this.OPEN) {
      return this.wsocket.url
    } else {
      return (this.protocol || "ws") + "://" + (this.host || "127.0.0.1") + ":" + (this.port || 54321)
    }
  };
  ws.prototype.send = function (g) {
    if (this.wsocket && this.wsocket.readyState === 1) {
      var h = "";
      if (typeof(g) === "string") h = g; else if (typeof(g) === "object") h = JSON.stringify(g, null, 2); else {
        var i = generateEvent('error', {"message": "Invalid data format, only json string or json object is allowed."});
        e.dispatchEvent(i);
        return
      }
      ;
      try {
        h = btoa(unescape(encodeURIComponent(h)));
        h = "base64:" + h;
        this.wsocket.send(h)
      } catch (e) {
        var i = generateEvent('error', {"message": e.message});
        e.dispatchEvent(i)
      }
    } else {
      var h = generateEvent('error', {"message": "Not connected to cfprint server or disconnected."});
      e.dispatchEvent(h);
    }
  };
  ws.prototype.close = function (g, h) {
    if (typeof g === 'undefined') g = 1000;
    if (this.wsocket) this.wsocket.close(g, h)
  };
  ws.prototype.open = function () {
    var g = this;
    this.url = this.getURL();
    d = new WebSocket(this.url, this.protocol || []);
    e.dispatchEvent(generateEvent('connecting'));
    d.onopen = function (h) {
      g.protocol = ws.protocol;
      g.readyState = WebSocket.OPEN;
      var i = generateEvent('open');
      e.dispatchEvent(i)
    };
    d.onclose = function (h) {
      g.readyState = WebSocket.CLOSED;
      var i = generateEvent('connecting');
      i.code = h.code;
      i.reason = h.reason;
      i.wasClean = h.wasClean;
      e.dispatchEvent(i);
      e.dispatchEvent(generateEvent('close'))
    };
    d.onmessage = function (h) {
      var i = generateEvent('message');
      i.data = h.data;
      e.dispatchEvent(i)
    };
    d.onerror = function (h) {
      var i = generateEvent('error');
      e.dispatchEvent(i)
    };
    this.wsocket = d;
    return this
  };
  ws.prototype.state = function () {
    if (this.wsocket) {
      return this.wsocket.readyState
    } else {
      return WebSocket.CLOSED
    }
  };
  ws.prototype.log = function (g, h) {
    var i = this.output || "output";
    var j = document.getElementById(i);
    if (j && j.appendChild) {
      var k = document.createElement("p");
      k.style.wordWrap = "break-word";
      k.style.padding = "8px";
      k.style.background = "#eee";
      k.innerHTML = "LOG: " + g;
      if (j.childNodes.length > 0) j.insertBefore(k, j.childNodes[0]); else j.appendChild(k)
    }
    ;h ? console.log(g, h) : console.log(g)
  };
  return ws
}));